#include <iostream>
#include <conio.h>
#include <thread>
#include <chrono>
#include <future>

using namespace std;

int a, b, c;

void getUserData(void)
{
	cout << "Input a: ";
	cin >> a;

	cout << "Input b: ";
	cin >> b;

	return;
}

void showResult(void)
{
	cout << "The result is " << c << endl;
	cout << "Press any key...";
	_getch();
}

void introduceRandomDelay()
{
	// simulates a delay between 1 and 3 seconds.
	this_thread::sleep_for(chrono::seconds(rand()%3+1));
}

int calculateA()
{
	cout << "Calculating A..." << endl;
	introduceRandomDelay();
	return b*(b+1)-b;
}

int calculateB()
{
	cout << "Calculating B..." << endl;
	introduceRandomDelay();
	return a*(a+a*(a+1));
}

int calculateC()
{
	cout << "Calculating C..." << endl;
	introduceRandomDelay();
	return a+a*b;
}

int main(int argc, char *argv[])
{
	cout.sync_with_stdio(true);
	getUserData();
	future<int> f1 = async(calculateB), f2 = async(calculateC);
	c = (calculateA() + f1.get()) * f2.get();
	showResult();
}