#include <iostream>
#include <conio.h>
#include <thread>
#include <chrono>
#include <future>

using namespace std;

int a, b, c;

void getUserData(void)
{
	cout << "Input a: ";
	cin >> a;

	cout << "Input b: ";
	cin >> b;

	return;
}

void showResult(void)
{
	cout << "The result is " << c << endl;
	cout << "Press any key...";
	_getch();
}

void introduceRandomDelay()
{
	// simulates a delay between 1 and 3 seconds.
	this_thread::sleep_for(chrono::seconds(rand()%3+1));
}

int calculateA()
{
	introduceRandomDelay();
	return b*(b+1)-b;
}

int calculateB()
{
	introduceRandomDelay();
	return a*(a+a*(a+1));
}

int calculateC()
{
	introduceRandomDelay();
	return a+a*b;
}

typedef int (*calculate)(void);
void func2promise(calculate f, promise<int> &p)
{
	p.set_value(f());
}

int main(int argc, char *argv[])
{
	getUserData();
	promise<int> p1, p2;
	future<int> f1 = p1.get_future(), f2 = p2.get_future();
	thread t1(&func2promise, calculateB, std::ref(p1)),
		t2(&func2promise, calculateC, std::ref(p2));
	c = (calculateA() + f1.get()) * f2.get();
	t1.join(); t2.join();
	showResult();
}